#!/usr/bin/perl
# ___________________________________________________________________________
#
# WhatsTheSiteRunning Perl Script v1.2 
# Copyright 1999-2000 by Dennis D. Spreen (dennis@spreendigital.de)
#
# A small script to find out what server a particular site is currently running
#
#  http://www.spreendigital.de/perl/wtsr/
# ___________________________________________________________________________

require LWP::UserAgent;

# The latest version of the LWP library is likely to be available from:
# http://www.sn.no/libwww-perl/

# If you are behind a firewall or proxy, uncomment this line 
# and fill in your proxy settings

#$proxy   = 'http://192.168.0.20:8080/';


# As by default, we add a "Pragma: no-cache" header to each request
# to ensure we're not retrieving any proxy-cached responses.
# Set to zero if you experience any problems

$nocache = 1;

# Set a time out if the host doesn't answer. Set to 3 minutes 
# (=180 seconds) by default

$timeout = 180;

# ___________________________________________________________________________

$host = shift || '';

if (!$host) { print "$0 <host[:port]>";exit; }

$ua = new LWP::UserAgent;
$ua->agent("wtsr.pl/1.2 ($^O)");
$ua->proxy('http', $proxy) if ($proxy);
$ua->timeout($timeout);

$request = new HTTP::Request('GET', "http://$host/");
$request->header(Pragma => 'no-cache') if ($nocache);
$response = $ua->simple_request($request);
$server = $response->server;

if (($response->is_success)||($server)) 
 {
   print "$host is running $server\n";
 }
else 
 {
   print "$host is unreachable/unknown";
 }

# ___________________________________________________________________________
